#include <stdlib.h>
#include <string.h>

#include "vector.h"

vector* vector_create()
{
	vector* v = (vector*)malloc(sizeof(vector));
	v->size = 0;
	v->capacity = VECTOR_CAPACITY_INIT;
	v->data = (float*)malloc(v->capacity * sizeof(float));
	return v; 
}

void vector_destroy(vector* v)
{
	free(v->data);
	free(v);
	v = NULL;
}

void vector_push(vector* v, float item)
{
	if(v->size == v->capacity)
	{
		v->capacity *= VECTOR_CAPACITY_MUL;
		v->data = realloc(v->data, v->capacity * sizeof(float));
	}
	
	v->data[v->size] = item;
	++v->size;
}

void vector_pop(vector* v)
{
	if(v->size > 0)
	{
		--v->size;
	}
}

float vector_back(vector* v)
{
	if(v->size > 0)
	{
		return v->data[v->size - 1];
	}
	else
	{
		return 0;
	}
}

float vector_get(vector* v, int idx)
{
	if(idx >= 0 && idx < v->size)
	{
		return v->data[idx];
	}
	else
	{
		return 0;
	}
}

void vector_set(vector* v, int idx, float item)
{
	if(idx >= 0 && idx < v->size)
	{
		v->data[idx] = item;
	}
}

void vector_copy(vector* dest, vector* src)
{
	if(src == dest)
		return;
		
	dest->size = src->size;
	dest->capacity = src->capacity;
	dest->data = (float*)realloc(dest->data, dest->capacity * sizeof(float));
	
	// Version 1
	/*for(int i = 0; i < dest->size; ++i)
	{
		dest->data[i] = src->data[i];
	}*/
	
	// Version 2
	memcpy(dest->data, src->data, dest->size * sizeof(float));
}
